import { Action } from "./Action";
/**
  * Node represents a stateful nodes in the protocol
  */
export declare class Node {
    /**
     * name
     */
    private _name;
    /**
     * states
     */
    private _states;
    /**
     * currentState
     */
    private _currentState;
    /**
     * all the actions of thie node
     */
    private _actions;
    constructor(name: string, init: string, states: Set<string>);
    addAction(action: Action): void;
    get name(): string;
    set currentState(state: string);
    get currentState(): string;
    /**
     * tranfter to new state
     */
    transferTo(to: string): void;
    getAction(actionName: string): Action;
    /**
     * get the all the actions signatures , which is in format:
     *   node_name:action_name:tag
     * where
     *   - node_name   name of this node
     *   - action_name name of this action
     *   - tag         if positive '+' else '-'
     */
    actionSignatures(): string[];
}
